
//#include "metalShaderTypes.h"

typedef struct
{
	float zoom;
	float size;
	float colorSeparation;
} fxVars;

vertex vertexOut vertexFunc(uint vertexID [[ vertex_id ]],const device txShaderVers* in[[ buffer(0) ]],constant txShaderUniforms& uniforms[[ buffer(3) ]],constant fxVars& vars[[ buffer(2)]])
{
    vertexOut out;

    out.position=in[vertexID].pos*uniforms.worldViewProj;

    out.tex1=in[vertexID].tex1;
	out.tex2=in[vertexID].tex2;
	out.texMask=in[vertexID].texMask;
    return out;
}

fragment float4 fragmentFunc(vertexOut in [[stage_in]]
							 ,texture2d<half> inputTex0 [[ texture(0) ]]
							 ,texture2d<half> inputTex1 [[ texture(1) ]]
							 ,texture2d<half> inputTexMask [[ texture(2) ]]
							 ,constant txShaderUniforms& u[[ buffer(2) ]]
							 ,constant fxVars& vars[[ buffer(1)]])
{
	float inv = 1. - u.transitionProgressLinear;
	vec2 disp = vars.size*vec2(cos(vars.zoom*in.tex1.x), sin(vars.zoom*in.tex1.y));
	vec2 disp2=vars.size*vec2(cos(vars.zoom*in.tex2.x), sin(vars.zoom*in.tex2.y));

	vec4 colorIn=tex(inputTex0,(in.tex1+inv*disp));

	float progress=u.transitionProgressLinear;
	vec4 colorOut;

	colorOut.r=tex(inputTex1,(in.tex2+progress*disp2*(1.0-vars.colorSeparation))).r;
	colorOut.ga=tex(inputTex1,(in.tex2+progress*disp2)).ga;
	colorOut.b=tex(inputTex1,(in.tex2+progress*disp2*(1.0+vars.colorSeparation))).b;

	float4 outColor=mix(colorOut,colorIn,u.transitionProgress);
#ifdef USE_MASK
	outColor.a*=float(inputTexMask.sample(linearSampler,in.texMask).a);
#endif

	return outColor;
}
