
//#include "metalShaderTypes.h"

vertex vertexOut vertexFunc(uint vertexID [[ vertex_id ]],const device txShaderVers* in[[ buffer(0) ]],constant txShaderUniforms& uniforms[[ buffer(3) ]])
{
    vertexOut out;

    out.position=in[vertexID].pos*uniforms.worldViewProj;

    out.tex1=in[vertexID].tex1;
	out.tex2=in[vertexID].tex2;
	out.texMask=in[vertexID].texMask;
    return out;
}

fragment float4 fragmentFunc(vertexOut in [[stage_in]]
							 ,texture2d<half> inputTex0 [[ texture(0) ]]
							 ,texture2d<half> inputTex1 [[ texture(1) ]]
							 ,texture2d<half> inputTexMask [[ texture(2) ]]
							 ,constant txShaderUniforms& u[[ buffer(2) ]])
{
	vec4 texColor = tex(inputTex0,in.tex1);
	vec4 colorA=mix(vec4(0,0,0,0),texColor,u.mix);
	vec4 colorB=mix(texColor,vec4(0,0,0,0),u.mix);
	
	float4 outColor;
    if(u.transitionProgressLinear<=.5)
    {
		outColor=colorB;
		outColor.rgb+=(u.transitionProgress*2.);
    }
    else
    {
		outColor=colorA;
		outColor.rgb+=(1.-u.transitionProgress)*2.;
    }

#ifdef USE_MASK
	outColor.a*=float(inputTexMask.sample(linearSampler,in.texMask).a);
#endif

	return outColor;
}
